#include "StdAfx.h"
#include "WriteMain.h"

extern HINSTANCE g_instance;

CWriteMain::CWriteMain(void)
{
	this->file = NULL;
	this->writeBuff = NULL;
	this->writeBuffSize = 0;
	this->writeBuffPos = 0;

	WCHAR dllPath[512] = L"";
	GetModuleFileName(g_instance, dllPath, 512);

	wstring iniPath = dllPath;
	iniPath += L".ini";

	this->writeBuffSize = (DWORD)GetPrivateProfileIntW(L"SET", L"Size", 770048, iniPath.c_str());
	SAFE_DELETE_ARRAY(this->writeBuff);
	if( this->writeBuffSize > 0 ){
		this->writeBuff = new BYTE[this->writeBuffSize];
	}
	this->writeBuffPos = 0;

	//ۑPID}bv쐬
	for(int i=0; i< 8192; i++) pid_map[i] = 0;
	WCHAR buff[1024] = L"";
	DWORD len = GetPrivateProfileStringW(L"SET", L"PID", L"0x1070-0x1079", buff, sizeof(buff)/sizeof(WCHAR), iniPath.c_str());
	WCHAR *p, *next = buff;
	do {
		p = next;
		next = wcschr(p, L',');
		if (next && *next==L',') *(next++) = 0;
		WCHAR *hyphen = wcschr(p, L'-');
		if (hyphen) {
			*(hyphen++) = 0;
			long s = wcstol(p, NULL, 0), e = wcstol(hyphen, NULL, 0);
			if (s<0) s = 0;
			for(int i = s; i<= e && i< 8192; i++) pid_map[i] = 1;
		} else {
			long n = wcstol(p, NULL, 0);
			if( (n >= 0) && (n < 8192) ) pid_map[n] = 1;
		}
	} while(next);
	int check = (int)GetPrivateProfileIntW(L"SET", L"Exclusive", 0, iniPath.c_str());
	if (check) {
		for(int i=0;i<8192;i++){
			pid_map[i] = 1-pid_map[i];
		}
	}
}


CWriteMain::~CWriteMain(void)
{
	if( this->file != NULL ){
		_StopSave();
	}

	SAFE_DELETE_ARRAY(this->writeBuff);
	this->writeBuffSize = 0;
	this->writeBuffPos = 0;
}

//t@CۑJn
//߂lF
// TRUEijAFALSEisj
//F
// fileName				[IN]ۑt@CtpXiKvɉĊgqςȂǍsj
// overWriteFlag		[IN]t@Cݎɏ㏑邩ǂiTRUEFAFALSEFȂj
// createSize			[IN]͗\zeʁi188oCgTSł̗eʁB^掞ȂǑԖ̏ꍇ0BȂǂ̉\̂Ŗڈxj
BOOL CWriteMain::_StartSave(
	LPCWSTR fileName,
	BOOL overWriteFlag,
	ULONGLONG createSize
	)
{
	this->savePath = L"";

	wstring errMsg = L"";
	DWORD err = 0;

	wstring recFilePath = fileName;
	if( overWriteFlag == TRUE ){
		_OutputDebugString(L"_StartSave CreateFile:%s", recFilePath.c_str());
		this->file = _CreateFile2( recFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
		if( this->file == INVALID_HANDLE_VALUE ){
			err = GetLastError();
			GetLastErrMsg(err, errMsg);
			_OutputDebugString(L"_StartSave Err:0x%08X %s", err, errMsg.c_str());
			if( GetNextFileName(fileName, recFilePath) == TRUE ){
				_OutputDebugString(L"_StartSave CreateFile:%s", recFilePath.c_str());
				this->file = _CreateFile2( recFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
			}
		}
	}else{
		_OutputDebugString(L"_StartSave CreateFile:%s", recFilePath.c_str());
		this->file = _CreateFile2( recFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL );
		if( this->file == INVALID_HANDLE_VALUE ){
			err = GetLastError();
			GetLastErrMsg(err, errMsg);
			_OutputDebugString(L"_StartSave Err:0x%08X %s", err, errMsg.c_str());
			if( GetNextFileName(fileName, recFilePath) == TRUE ){
				_OutputDebugString(L"_StartSave CreateFile:%s", recFilePath.c_str());
				this->file = _CreateFile2( recFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL );
			}
		}
	}
	if( this->file == INVALID_HANDLE_VALUE ){
		err = GetLastError();
		GetLastErrMsg(err, errMsg);
		_OutputDebugString(L"_StartSave Err:0x%08X %s", err, errMsg.c_str());
		this->file = NULL;
		return FALSE;
	}

	//fBXNɗeʂm
	if( createSize > 0 ){
		LARGE_INTEGER stPos;
		stPos.QuadPart = createSize;
		SetFilePointerEx( this->file, stPos, NULL, FILE_BEGIN );
		SetEndOfFile( this->file );
		CloseHandle( this->file );
		this->file = _CreateFile2( recFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
		SetFilePointer( this->file, 0, NULL, FILE_BEGIN );
	}

	this->savePath = recFilePath;

	return TRUE;
}

//t@CۑI
//߂lF
// TRUEijAFALSEisj
BOOL CWriteMain::_StopSave(
	)
{
	if( this->file != NULL ){
		if( this->writeBuffPos > 0 ){
			DWORD writeSize = 0;
			DWORD err = 0;
			wstring errMsg = L"";
			if( WriteFile(this->file, this->writeBuff, this->writeBuffPos, &writeSize, NULL) == FALSE ){
				err = GetLastError();
				GetLastErrMsg(err, errMsg);
				_OutputDebugString(L"_StopSave WriteFile Err:0x%08X %s", err, errMsg.c_str());
			}else{
				this->writeBuffPos = 0;
			}
		}
		SetEndOfFile(this->file);
		CloseHandle(this->file);
		this->file = NULL;
	}

	return TRUE;
}

//ۂɕۑĂt@CpX擾iĐob`ɗpj
//filePathNULL͕KvȃTCYfilePathSizeŕԂ
//ʏfilePathSize=512ŌĂяo
//߂lF
// TRUEijAFALSEisj
//F
// filePath				[OUT]ۑt@CtpX
// filePathSize			[IN/OUT]filePath̃TCY(WCHARP)
BOOL CWriteMain::_GetSaveFilePath(
	WCHAR* filePath,
	DWORD* filePathSize
	)
{
	if( filePath == NULL ){
		if( filePathSize == NULL ){
			return FALSE;
		}else{
			*filePathSize = (DWORD)this->savePath.size()+1;
		}
	}else{
		if( filePathSize == NULL ){
			return FALSE;
		}else{
			if( *filePathSize < (DWORD)this->savePath.size()+1 ){
				*filePathSize = (DWORD)this->savePath.size()+1;
				return FALSE;
			}else{
				wcscpy_s(filePath, *filePathSize, this->savePath.c_str());
			}
		}
	}
	return TRUE;
}

//ۑpTSf[^𑗂
//󂫗eʕsȂǂŏosꍇAwriteSize̒l
//ēxۑƂ̑MJnn_߂
//߂lF
// TRUEijAFALSEisj
//F
// data					[IN]TSf[^
// size					[IN]datãTCY
// writeSize			[OUT]ۑɗpTCY
BOOL CWriteMain::_AddTSBuff(
	BYTE* data,
	DWORD size,
	DWORD* writeSize
	)
{
	BOOL ret = FALSE;
	wstring errMsg = L"";
	DWORD err = 0;
	//ŃpPbgtB^Ă݂
	*writeSize = 0;
	BYTE *p = data;
	int remain = (int)size;
	while(remain>0) {
		//
		if (*p!=0x47) {
			p++;
			remain--;
			continue;
		}
		//obt@ςɂȂĂ邩mF
		if(this->writeBuffSize <= this->writeBuffPos + 188 -1 ){
			//obt@o
			DWORD tempWriteSize = 0;
			if( WriteFile(this->file, this->writeBuff, this->writeBuffSize, &tempWriteSize, NULL) == FALSE ){
				//G[
				err = GetLastError();
				GetLastErrMsg(err, errMsg);
				_OutputDebugString(L"_StopSave WriteFile Err:0x%08X %s", err, errMsg.c_str());
				//t@C|C^߂
				LONG lpos = (LONG)tempWriteSize;
				SetFilePointer(this->file, -lpos, NULL, FILE_CURRENT);

				SetEndOfFile(this->file);
				CloseHandle(this->file);
				this->file = NULL;
				return FALSE;
			}
			this->writeBuffPos = 0;
		}
		//pPbge
		int transport_error_indicator    = (p[1] >> 7) & 0x01;
		int payload_unit_start_indicator = (p[1] >> 6) & 0x01;
		int transport_priority           = (p[1] >> 5) & 0x01;
		int pid                          = ((p[1] & 0x1f) << 8) | p[2];
		int transport_scrambling_control = (p[3] >> 6) & 0x03;
		int adaptation_field_control     = (p[3] >> 4) & 0x03;
		int continuity_counter           =  p[3]       & 0x0f;
		if (pid_map[pid]) {
			//pPbgobt@ɃRs[
			memcpy( this->writeBuff+this->writeBuffPos, p, 188 );
			this->writeBuffPos += 188;
		}
		p+=188;
		remain-=188;
		*writeSize += 188;
	}
	return TRUE;
}

BOOL CWriteMain::GetNextFileName(wstring filePath, wstring& newPath)
{
	WCHAR szPath[_MAX_PATH];
	WCHAR szDrive[_MAX_DRIVE];
	WCHAR szDir[_MAX_DIR];
	WCHAR szFname[_MAX_FNAME];
	WCHAR szExt[_MAX_EXT];
	_wsplitpath_s( filePath.c_str(), szDrive, _MAX_DRIVE, szDir, _MAX_DIR, szFname, _MAX_FNAME, szExt, _MAX_EXT );
	_wmakepath_s(  szPath, _MAX_PATH, szDrive, szDir, NULL, NULL );

	BOOL findFlag = FALSE;
	for( int i=1; i<1000; i++ ){
		WIN32_FIND_DATA findData;
		HANDLE find;

		wstring name;
		Format(name, L"%s%s-(%d)%s", szPath, szFname, i, szExt);
		newPath = name;
		
		find = FindFirstFile( newPath.c_str(), &findData);
		if ( find == INVALID_HANDLE_VALUE ) {
			findFlag = TRUE;
			break;
		}
		FindClose(find);
	}
	return findFlag;
}
